import string, os.path
from qt import *
from charmap import uniCharmap
from pinyin  import uniPinyin

TRUE=1
FALSE=0

class uniMultiLineEditor(QMultiLineEdit): 
  """keymap={Qt.Key_A: QString(u"\u0270")}
  
  def keyPressEvent(self, ev):
    if uniMultiLineEditor.keymap.has_key(ev.key()):
      self.insert(uniMultiLineEditor.keymap[ev.key()])
    else:
      QMultiLineEdit.keyPressEvent(self, ev)
  """    
  def __init__(self, *args):
    apply(QMultiLineEdit.__init__, (self, ) + args )
    
class QCharView(QSplitter):

  def __init__(self, parent, font,  *args):
    apply(QSplitter.__init__,(self, parent, )+args)
    self.setOrientation(QSplitter.Vertical)
    self.font=font
    self.font.setCharSet(QFont.Unicode)
    self.editField=uniMultiLineEditor(self)
    self.editField.setFont(self.font)

    self.container=QWidget(self)
    self.box=QVBoxLayout(self.container)
    
    self.tabIME=QTabBar(self.container)
    self.stackIME=QWidgetStack(self.container)
    
    self.box.addWidget(self.tabIME)
    self.box.addWidget(self.stackIME)
    
    self.tabIME.addTab(QTab("Character picker"))
    self.boxCP=QVBox(self.stackIME)
    self.stackIME.addWidget(self.boxCP, 0)
    self.characterPicker=uniCharmap(self.boxCP, self.font)
    self.connect(self.characterPicker, PYSIGNAL("sigCharacterSelected")
                         , self.editField.insert
                         )

   
    self.tabIME.addTab(QTab("Pinyin Entry"))
    self.boxPY=QVBox(self.stackIME)
    self.stackIME.addWidget(self.boxPY, 1)
    self.pinyinPicker=uniPinyin(self.boxPY, self.font)
    self.connect(self.pinyinPicker, PYSIGNAL("sigCharacterSelected")
                         , self.editField.insert
                         )
    
    self.connect(self.tabIME, SIGNAL("selected(int)")
                            , self.selectIME
                            )
    #self.editField.setFocus()
    self.stackIME.raiseWidget(0)
    
  def setFont(self, font):
    self.font=font
    self.editField.setFont(self.font)
    self.characterPicker.setFont(self.font)
    self.pinyinPicker.setFont(self.font)

  def clear(self):
    self.editField.clear()
    
  def copy(self):
    self.editField.selectAll()
    self.editField.copy()
    self.editField.copy()

  def selectIME(self, tabIME):
    self.stackIME.raiseWidget(tabIME)


__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.4 $
    Last edited          : $Date: 2001/01/30 18:06:53 $
    
    CVS Log:         
    $Log: view.py,v $
    Revision 1.4  2001/01/30 18:06:53  boud
    Made a package.

    Revision 1.3  2001/01/08 20:54:56  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
