#!/usr/bin/env python

import sys

from qt import *

from frmpreferences import frmPreferences
from kuralib.config import Config, initCurrentEnvironment
from kuragui.guiconfig import guiConfig

from kuracomboproxy import comboProxy

from resource import *

class dlgPreferences(frmPreferences):
  """
  Proxy class for the; generated frmPreferences.
  $Revision: 1.11 $: $Date: 2001/01/08 20:55:06 $
  """
  def __init__(self, parent):
    frmPreferences.__init__(self, parent=parent, modal=TRUE)

    self.cmbUserProxy=comboProxy(comboBox=self.cmbUser, tableName="lng_user", currentKey=Config.usernr)
    self.cmbLanguageProxy=comboProxy(self.cmbLanguage, "lng_language", Config.languagenr)
    self.cmbProjectProxy=comboProxy(self.cmbProject, "lng_project", Config.projectnr)
    self.chkUseDefaultForSearch.setChecked(Config.useDefaultForSearch)
    self.chkShowValueHint.setChecked(Config.ShowValueHint)
   
    self.txtTextTemplate.setText(Config.InterLinearTextPresentation)
    self.txtStreamTemplate.setText(Config.InterlinearStreamPresentation)
    self.txtElementTemplate.setText(Config.InterLinearElementPresentation)

    self.cmbTextSortCriterion.insertStrList(TEXT_SORT_LIST)
    self.cmbTextSortCriterion.setCurrentItem(TEXT_SORT_LIST.index(Config.textSortCriterion))

    self.cmbStyle.insertStrList(STYLE_LIST)
    self.cmbStyle.setCurrentItem(STYLE_LIST.index(Config.currentStyle))
    
    self.lblFont.setText(Config.font.family())
    self.lblFont.setFont(Config.font)
    self.connect(self.bnFont, SIGNAL("clicked()"), self.slotGetFont)
    
      
  def savePreferences(self):    
    try:
      Config.usernr=self.cmbUserProxy.currentKey()
    except:
      pass
    try:
      Config.languagenr=self.cmbLanguageProxy.currentKey()
    except:
      pass
    try:
      Config.projectnr=self.cmbProjectProxy.currentKey()
    except:
      pass
    Config.useDefaultForSearch=self.chkUseDefaultForSearch.isChecked()
    Config.ShowValueHint=self.chkShowValueHint.isChecked()
    Config.InterLinearTextPresentation=str(self.txtTextTemplate.text())
    Config.InterlinearStreamPresentation=str(self.txtStreamTemplate.text())
    Config.InterLinearElementPresentation=str(self.txtElementTemplate.text())

    Config.textSortCriterion=str(self.cmbTextSortCriterion.currentText())

    Config.app.settings(usernr=Config.usernr, languagenr=Config.languagenr, projectnr=Config.projectnr)
 
  def slotGetFont(self):
    font, OK=QFontDialog.getFont(guiConfig.font, self)
    if OK:
      self.lblFont.setText(font.family())
      self.lblFont.setFont(font)
      Config.font=font
      Config.fontfamily=font.family()
      Config.pointSize=font.pointSize()
      Config.weight=font.weight()
      Config.italic=font.italic()
      Config.encoding=font.charSet()
      guiConfig.font=font
      

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.11 $
    Last edited          : $Date: 2001/01/08 20:55:06 $
    
    CVS Log:         
    $Log: dlgpreferences.py,v $
    Revision 1.11  2001/01/08 20:55:06  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
