import sys

from qt import *

from kuralib.config import Config
from kuralib.lng_lex import *
  
from kuragui.guitabdialog  import guiTabDialog
from kuragui.guilistview   import guiListView
from kuragui.guidetaillist import guiDetailList
from kuragui.constants     import *

from tabstreamtags     import tabStreamTags

from resource import *

class dlgStream(guiTabDialog):

    def __init__(self, app, parent, title, firstTabTitle, 
            record, mode, tableDef, showChildren=FALSE):
            
      guiTabDialog.__init__(self, app=app, parent=parent, title=title
         , firstTabTitle="&Streams", record=record
         , mode=mode, tableDef=tableDef, showChildren=FALSE, addBottomSpring=TRUE)

  

      tagstab=tabStreamTags(parent, app, record)
      guiTabDialog.addChildTab( self, "&Tags"
                           , tagstab, record, DETAIL)



def main():

  qapp=QApplication(sys.argv)
  toplevel=guiListView( Config.app
                      , tableName="lng_stream"
                      , searchRec=Config.app.createObject('lng_stream', streamnr="6")
                      , dlgForm=dlgStream
                      , dlgSearch=None
                      , parent=None
                      )
  toplevel.show()
  qapp.connect(qapp, SIGNAL('lastWindowClosed()'), qapp, SLOT('quit()'))
  qapp.exec_loop()
  
if __name__=="__main__":
  if len(sys.argv)>1:
    if sys.argv[1]=='-p':
      import profile
      profile.run('main()')
  else:
    main()

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.6 $
    Last edited          : $Date: 2001/01/30 20:04:42 $
    
    CVS Log:         
    $Log: dlgstream.py,v $
    Revision 1.6  2001/01/30 20:04:42  boud
    Removed print statements.

    Revision 1.5  2001/01/08 20:55:06  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
