import sys

from qt import *

from kuralib.config import Config
from kuralib.lng_lex import *
  
from kuragui.guitabdialog  import guiTabDialog
from kuragui.guilistview   import guiListView
from kuragui.guidetaillist import guiDetailList
from kuragui.constants     import *

from tabtexttags     import tabTextTags
from tabtextprojects import tabTextProjects

from resource import *

class dlgText(guiTabDialog):

  def __init__(self, app, parent, title, firstTabTitle, 
            record, mode, tableDef, showChildren=FALSE):
            
    guiTabDialog.__init__(self, app=app, parent=parent, title=title
       , firstTabTitle="&Texts", record=record
       , mode=mode, tableDef=tableDef, showChildren=FALSE)

    self.tagstab=tabTextTags(parent, app, record)
    guiTabDialog.addChildTab( self, "&Tags"
                         , self.tagstab, record, DETAIL)


    tabproj=tabTextProjects(parent, app, record)
    guiTabDialog.addChildTab(self, "&Projects"
                         , tabproj, record, DETAIL)

  def accept(self):
    try:
      self.tagstab.frmTextTags.save()
    except Exception, e:
      print str(e)
      pass
    guiTabDialog.accept(self)


def main():

  qapp=QApplication(sys.argv)
  toplevel=guiListView( Config.app
                      , tableName="lng_text"
                      , searchRec=Config.app.createObject('lng_text', textnr="6")
                      , dlgForm=dlgText
                      , dlgSearch=None
                      , parent=None
                      )
  toplevel.show()
  qapp.connect(qapp, SIGNAL('lastWindowClosed()'), qapp, SLOT('quit()'))
  qapp.exec_loop()
  
if __name__=="__main__":
  if len(sys.argv)>1:
    if sys.argv[1]=='-p':
      import profile
      profile.run('main()')
  else:
    main()

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.7 $
    Last edited          : $Date: 2001/01/30 20:27:57 $
    
    CVS Log:         
    $Log: dlgtext.py,v $
    Revision 1.7  2001/01/30 20:27:57  boud
    Unsaved added tags are now saved on OK.

    Revision 1.6  2001/01/30 20:04:42  boud
    Removed print statements.

    Revision 1.5  2001/01/08 20:55:06  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
