from qt import *

from dbobj.dbexceptions         import *

from kuragui.guidetaillist    import guiDetailList

from formtags                 import formTags
from kuracmbtags              import kuraCmbTags
from kuracmbtagvalues         import kuraCmbTagValues

from resource                 import TRUE, FALSE
from kuralib.config           import Config

class formElementTags(formTags):

  def newItem(self, parentRecord): 
    self.clear()
    self.setEnabled(TRUE)
    record=Config.app.createDefaultObject("lng_element_tag", elementnr=parentRecord.elementnr)
    self.setItem(record)
    
  def save(self):
    if self.record!=None:
      self.record.tag=self.cmbTags.currentKey()
      self.record.tagname=str(self.cmbTags.currentText())

      if self.cmbTagValues.isEnabled()==TRUE:
        self.record.value=self.cmbTagValues.currentKey()
        self.record.description=str(self.cmbTagValues.currentText())
      else:
        self.record.description=str(self.txtNote.text())[:200]
      self.record.note=self.txtNote.text()
     
      if self.lvi==None:
        try:
          self.record.insert()
          self.record=Config.app.getObject("lng_element_tag", element_tagnr=self.record.element_tagnr)
          self.emit(PYSIGNAL("sigRecordInserted"),(self.record,))
        except dbError, dberr:
          QMessageBox.information(self, "Kura Error while inserting", dberr.error)

      else:
        try:
          self.record.update()
          self.emit(PYSIGNAL("sigRecordUpdated"),(self.record,self.lvi))
        except dbError, dberr:
          QMessageBox.information(self, "Kura Error while updating", dberr.error)

class tabElementTags(QWidget):

  def __init__(self, parent, app, parentRecord, *args):
    QWidget.__init__(self, parent)

    self.grid = QGridLayout(self)
    self.grid.setSpacing(6)
    self.grid.setMargin(11)
    
    self.dlsTags=guiDetailList(self, app, parentRecord, "lng_element_tag")
    self.frmElementTags=formElementTags(self, "lng_element", "lng_element_tag")
    
    self.grid.addWidget(self.dlsTags, 0, 0)
    self.grid.addWidget(self.frmElementTags, 1, 0)

    self.connect(self.dlsTags, PYSIGNAL("sigRecordSelected"), self.frmElementTags.changeItem)
    self.connect(self.dlsTags, PYSIGNAL("sigItemDeleted"),    self.frmElementTags.clear)
    self.connect(self.dlsTags, PYSIGNAL("sigCreateNewItem"),  self.frmElementTags.newItem)
    self.connect(self.frmElementTags, PYSIGNAL("sigRecordUpdated"),  self.dlsTags.slotUpdateItem)
    self.connect(self.frmElementTags, PYSIGNAL("sigRecordInserted"), self.dlsTags.slotAddItem)    
    self.frmElementTags.clear()

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.5 $
    Last edited          : $Date: 2001/01/30 20:04:42 $
    
    CVS Log:         
    $Log: tabelementtags.py,v $
    Revision 1.5  2001/01/30 20:04:42  boud
    Removed print statements.

    Revision 1.4  2001/01/15 20:21:09  boud
    Added import/export filters, bugfixes.

    Revision 1.3  2001/01/08 20:55:06  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
