import sys
from kuralib.config import Config
from kuradom import KuraDOM

TRUE=1
FALSE=0

class KuraDBReader:

  def __init__(self, *args):
    self._dom=KuraDOM()

  def _handleElement(self, qrElmt, qrEltg, r, parentElement=None, depth=TRUE):
    element=self._dom.addElement(r, parentElement)
    
    qrEltg.elementnr=element.elementnr
    for r in Config.app.sql.select(Config.app, "lng_element_tag", qrEltg):
      self._dom.addElementTag(r)
    if depth:
      qrElmt.parent_elementnr=element.elementnr
      for r in Config.app.sql.select(Config.app, "lng_element", qrElmt):
        self._handleElement(qrElmt, qrEltg, r, element)

  def clear(self):
    self._dom=KuraDOM()

  def getDom(self):
    return self._dom

  def start(self, textnr, depth=TRUE):

    qrText=Config.app.createObject("lng_text")
    qrTextTag=Config.app.createObject("lng_text_tag")
    qrStream=Config.app.createObject("lng_stream")
    qrStreamTag=Config.app.createObject("lng_stream_tag")
    qrElement=Config.app.createObject("lng_element")
    qrElementTag=Config.app.createObject("lng_element_tag")

    qrText.textnr=textnr
    for r in Config.app.sql.select(Config.app, "lng_text", qrText):
      text=self._dom.addText(r)

      qrTextTag.textnr=text.textnr
      for r in Config.app.sql.select(Config.app, "lng_text_tag", qrTextTag):
        self._dom.addTextTag(r)

      qrStream.textnr=text.textnr
      for r in Config.app.sql.select(Config.app, "lng_stream", qrStream):
        stream=self._dom.addStream(r)
        qrStreamTag.streamnr=stream.streamnr
        for r in Config.app.sql.select(Config.app, "lng_stream_tag", qrStreamTag):
          self._dom.addStreamTag(r)

        qrElement.streamnr=stream.streamnr
        qrElement.parent_elementnr=0
        for r in Config.app.sql.select(Config.app, "lng_element", qrElement):
          self._handleElement(qrElement, qrElementTag, r, None, depth)


def f(item):
  print item.table, item.getPrimaryKey()

def main(args):
  import time
  t=time.time()
  dbr=KuraDBReader()
  for arg in args:
    dbr.start(arg, TRUE)
  dbr.getDom().walkTree()
  print time.time() - t
  
if __name__=="__main__":
  main(sys.argv[1:])
