from qt import *
from dbobj.dbobj import dbError
from constants import *
from kuralib.config import Config # FIXME: find a better place for this
                                   # I'd prefer not to have the app constants
                                   # in the gui library.
class guiDialog(QTabDialog):

  def __init__(self, parent, title, mode, hint):
    QTabDialog.__init__(self, parent, title, FALSE, Qt.WStyle_DialogBorder)
    self.title=title
    self.setApplyButton()
    self.connect(self, SIGNAL("applyButtonPressed()")
                     , self.slotApplyButtonPressed)
    self.setSizeGripEnabled(TRUE)
    self.setOkButton()
    self.accepted=FALSE
    self.hint=hint
    self.mode=mode
    self.tabs=[]
        
    self.setCaption(title)
    self.setCancelButton("&Cancel")
    
    if self.hint!=None and self.hint!="":
      self.setHelpButton()
      self.connect(self, SIGNAL("helpButtonPressed()"), self.slotHelp)

    try: 
      w=getattr(Config, title + "_w")
      h=getattr(Config, title + "_h")
      self.resize(QSize(w, h))
    except:
      self.resize(self.minimumSize())

  def slotApplyButtonPressed(self):
    self.accepted=self.slotAcceptData()
      
  def accept(self):
    self.saveSize()
    if self.accepted:
      QDialog.accept(self)
    
  def reject(self):
    self.saveSize()
    QDialog.reject(self)
    
  def saveSize(self):
    setattr(Config, self.title + "_w", self.width())
    setattr(Config, self.title + "_h", self.height())
    
  def addChildTab(self, title, tabForm, record, type=MASTER):
    QTabDialog.addTab(self, tabForm, title)
    self.tabs.append((tabForm, record))
    
  def slotAcceptData(self):
    
    tabForm=self.tabs[0][0]
    
    for field, fieldDef in tabForm.fieldList:

      if fieldDef.readonly:
        continue

      self.tabs[0][1].setFieldValue(field, tabForm.getFieldValue(field))
      if fieldDef.relation<>None: #combobox
        self.tabs[0][1].setFieldValue(self.tabs[0][1]
                                        .getDescriptorColumnName(field)
                                     , tabForm.getFieldText(field))
        fieldDef.default=tabForm.getFieldValue(field)
        
    if self.mode == INSERT:
      try:
        self.tabs[0][1].insert()
        self.mode = UPDATE
      except dbError, dberr:
        QMessageBox.information(self, "Kura Error while inserting"
                                    , dberr.errorMessage)
        return FALSE
        
    elif self.mode == UPDATE:	
      try:
        self.tabs[0][1].update()
      except dbError, dberr:
        QMessageBox.information(self, "Kura Error while updating"
                                    , dberr.errorMessage)
        return FALSE

    self.emit(PYSIGNAL("sigAcceptData"), (self.getMasterRecord(),))
    return TRUE
    
  def getMasterRecord(self):
    return self.tabs[0][1]
      
  def slotHelp(self):
    QMessageBox.information(self, "About " + 
                self.firstTabTitle.replace("&",""), self.hint)
__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.13 $
    Last edited          : $Date: 2001/01/30 20:04:43 $
    
    CVS Log:         
    $Log: guidialog.py,v $
    Revision 1.13  2001/01/30 20:04:43  boud
    Removed print statements.

    Revision 1.12  2001/01/25 23:04:22  boud
    Made non-modal

    Revision 1.11  2001/01/15 20:21:15  boud
    Added import/export filters, bugfixes.

    Revision 1.10  2001/01/08 20:55:07  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
