from qt            import *

from guidialog     import guiDialog
from guidetaillist import guiDetailList
from guiform       import guiForm
from constants     import *

from dbobj.dbobj   import dbError


class guiTabDialog(guiDialog):
  def __init__(self, app, parent, title, firstTabTitle,
        record, mode, tableDef, showChildren=FALSE, addBottomSpring=FALSE):
        
    guiDialog.__init__(self, parent, title, mode, tableDef.hint)

    self.firstTabTitle=firstTabTitle
    self.tableDef=tableDef
    self.hint=tableDef.hint
    self.mode=mode
    self.app=app
    
    tabForm=guiForm(self, record, self.mode)
    if addBottomSpring:
      tabForm.grdFields.addItem( QSpacerItem(20,20,QSizePolicy.Expanding, QSizePolicy.Expanding))
    guiDialog.addChildTab(self, firstTabTitle, tabForm, record)
    
    if (showChildren==TRUE and self.mode==UPDATE):
      for childName, childDef in self.tableDef.childtables.items():
        self.addAutoChildTab(record, childDef.childTable, childDef)
    
  def addAutoChildTab(self,  parentRec, childTable, childDef):
    tab=guiDetailList( parent=self
                     , app=self.app
                     , parentRecord=parentRec
                     , childTable=childTable
                     )
    guiDialog.addChildTab( self, self.app.getTableLable(childTable)
                         , tab, parentRec, DETAIL)


__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.11 $
    Last edited          : $Date: 2001/01/08 20:55:07 $
    
    CVS Log:         
    $Log: guitabdialog.py,v $
    Revision 1.11  2001/01/08 20:55:07  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
