from dbobj.dbobj import dbRecord
TRUE=1
FALSE=0
class AbstractTag(dbRecord):
  tagDefs={}
  tagTypes={}
  tagDomains={}
  tagReferences={}
  
  def __init__(self, app, table, fields={}):
    dbRecord.__init__(self, app, table, fields)

  def __cache(self, cache, key, tableName, **args):
    if cache.has_key(key):
      return cache[key]
    else:
      rec=self.app.getObject(tableName, fields=args)
      cache[key]=rec
      return rec

  def getDescription(self, showifnone=TRUE):
    # caching
    tagDefinition=self.__cache( AbstractTag.tagDefs, self.tag, "lng_tag", tag=self.tag)
    tagType=self.__cache( AbstractTag.tagTypes, tagDefinition.tagtypecode, "lng_tagtypecode"
                        , tagtypecode=tagDefinition.tagtypecode)
               
    if int(tagType.isdomain)==TRUE:
      if self.value==None:
        desc=None
      else:
        tagDomain=self.__cache( AbstractTag.tagDomains, self.value, "lng_tagdomain"
                              , tag=self.tag, domainnr=self.value)
        desc=tagDomain.abbreviation
      
    elif int(tagType.isnote)==TRUE:
      desc=self.note
      
    elif int(tagType.isreference)==TRUE:
      if self.value==None:
        desc=None
      else:
        tagReference=self.__cache( AbstractTag.tagReferences, tag.value
                                 , "lng_reference", referencenr=tag.value)
        desc=tagReference.getDescription()
      
    else:
      desc=self.value

    if desc==None:
      if int(showifnone)==TRUE:
        return ("<%s: None>" % self.tag)
      else:
        return ""
    else:
      return desc

  def getNewDescription(self):
    """
    Get a description for a tag if it has some value
    """
    tagDefinition=self.__cache( AbstractTag.tagDefs, self.tag, "lng_tag", tag=self.tag)
    tagType=self.__cache( AbstractTag.tagTypes, tagDefinition.tagtypecode, "lng_tagtypecode"
                        , tagtypecode=tagDefinition.tagtypecode)
                        
    if int(tagType.isdomain)==TRUE:
      if self.value=="" or self.value==None:
        return "<None>"
      tagDomain=self.__cache( AbstractTag.tagDomains, self.value, "lng_tagdomain"
                            , tag=self.tag, domainnr=self.value)
      return tagDomain.abbreviation
      
    elif int(tagType.isnote)==TRUE:
      if self.note=="" or self.note==None:
        return "<None>"
      return self.note
      
    elif int(tagType.isreference)==TRUE:
      if self.value=="" or self.value==None:
        return "<None>"
      tagReference=self.__cache( AbstractTag.tagReferences, tag.value
                               , "lng_reference", referencenr=tag.value)
      return tagReference.getDescription()
      
    else:
      if self.value=="" or self.value==None:
        return "<None>"
      return self.value

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.4 $
    Last edited          : $Date: 2001/01/15 20:21:15 $
    
    CVS Log:         
    $Log: lng_abstract_tag.py,v $
    Revision 1.4  2001/01/15 20:21:15  boud
    Added import/export filters, bugfixes.

    Revision 1.3  2001/01/08 20:55:07  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
