import string
from dbobj.dbexceptions import dbRecordNotFoundException
from dbobj.dbobj import dbRecord, dbTable

class lng_lex(dbRecord):
  def __init__(self, app, **args):
    if args.has_key("fields"):
      dbRecord.__init__(self, app, "lng_lex", args["fields"])
    else:
      dbRecord.__init__(self, app, "lng_lex", args)


  def lexHTML(self, out):
    # lng_lex
    fields=self.getFields()
    tpllex=open("/home/boud/src/python/prj/kura/kuraserver/templates/tpl_lexeme.html").read()
    out(tpllex % fields)    

    # lng_lex_tag
    tags=self.getChildren("lng_lex_tag")
    if len(tags)>0:
      out("""
<h2>Further information</h2><table>
<tr bgcolor="gray"><td><Entry></td><td>Value</td><td>Note</td></tr>
""")

      for tag in tags:
        out("<tr><td>%s</td><td>%s</td><td>%s</td></tr>" % (tag.tag, tag.value, tag.note))
      out("</table>")
      
    # examples
    out("<h2>Corpus</h2>")
    
    elements=self.app.getObjects("lng_element", languagenr=self.languagenr, text=string.lower(self.form))
    for element in elements:
      stream=self.app.getObject("lng_stream", streamnr=element.streamnr)
      stream.strmHTML(out)

  def getTag(self, tag):
    try:
      tagRecord=self.app.getObject("lng_lex_tag", lexnr=self.lexnr, tag=tag)
    except dbRecordNotFoundException, error:
      tagRecord=error.queryRec
    return tagRecord
      
    
class lng_lexemes(dbTable):
  """
    Collection class for all lexeme data.
  """
  
  def __init__(self, app):
    dbTable.__init__(self, app=app
                         , table="lng_lex"
                         , recObj=lng_lex
                    )
  def recordHTML(self, out, keys={}):
    queryRec=self.recObj(self.app, fields=keys)
    self.select(queryRec)
    for row in self.rows:
      row.lexHTML(out)

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.4 $
    Last edited          : $Date: 2001/01/30 20:04:45 $
    
    CVS Log:         
    $Log: lng_lex.py,v $
    Revision 1.4  2001/01/30 20:04:45  boud
    Removed print statements.

    Revision 1.3  2001/01/08 20:55:07  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
