from dbobj.dbobj import dbRecord
from string import join

class lng_language(dbRecord):

  def __init__(self, app, **args):
    if args.has_key("fields"):
      dbRecord.__init__(self, app, "lng_language", args["fields"])
    else:
      dbRecord.__init__(self, app, "lng_language", args)

  def getChildLanguages(self):
    """
       Get the entire tree of languages.
    """
    languages=[]
    rows=self.app.getObjects("lng_language", parent_languagenr=self.languagenr)
    languages=rows
    for language in rows:
      children=language.getChildLanguages()
      if children!=None:
        languages=languages + children
    return languages

from dbobj.dbobj import dbTable
   
class lng_languages(dbTable):
  """
    Collection class for all language data.
  """
  def __init__(self, app):
    dbTable.__init__(self, app, "lng_language", lng_language)

  def listHTML(self, out, keys={}):
    queryRec=lng_language(self.app, fields=keys)
    dbTable.select(self, queryRec)
    out("<dl>\n")
    for row in self.rows:
      fields=row.getFields()
      out("""
    <dt><em><a href="KURA?command=record?table=lng_language?languagenr=%(languagenr)s">
      <a name="%(languagenr)s">%(language)s</a>
    </a></em>
    </dt>
    <dd>
      %(description)s<br>
  """ % fields )      

      if fields["parent_language"]<>None:
        out('Parent language: <a href="<%(parent_languagenr)s">%(parent_language)s</a></dd><br>\n' % fields)
      out('<a href="KURA/table=lng_lex?command=contents?indexfield=form?languagenr=%(languagenr)s">Dictionary</a><br>' % fields)
      out('<a href="KURA/table=lng_text?command=contents?indexfield=title?languagenr=%(languagenr)s">Texts</a><br>' % fields)
      out('<a href="KURA/table=lng_document?command=contents?indexfield=title?languagenr=%(languagenr)s">Documents</a><br>' % fields)
      out('</dd>\n')
      
    out("</dl>\n")


__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.5 $
    Last edited          : $Date: 2001/01/30 20:04:45 $
    
    CVS Log:         
    $Log: lng_lngg.py,v $
    Revision 1.5  2001/01/30 20:04:45  boud
    Removed print statements.

    Revision 1.4  2001/01/08 20:55:07  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
