#!/usr/bin/env python
from dbobj.dbexceptions import dbRecordNotFoundException
from dbobj.dbobj import dbRecord, dbTable
from dbobj.dbtypes import *
from lng_strm import lng_stream, lng_streams
from lng_txtg import lng_text_tag

import re, string

class lng_text(dbRecord):

  def __init__(self, app, **args):
    if args.has_key("fields"):
      dbRecord.__init__(self, app, "lng_text", args["fields"])
    else:
      dbRecord.__init__(self, app, "lng_text", args)
    self.tags=[]
    self.streams=[]

  def translation(self):
    if self.tags==None:
      self.getTags()
    for tag in self.tags:
      if tag.tagtypecode=="TRNS":
        return tag.getDescription()
    return '-'
      
  def getTags(self):
    self.tags=self.getChildren("lng_text_tag")
    return self.tags
      
  def getTag(self, tag):
    try:
      tagRecord=self.app.getObject("lng_text_tag", textnr=self.textnr, tag=tag)
    except dbRecordNotFoundException, error:
      tagRecord=error.queryRec
    return tagRecord

  def removeStreams(self):
    for stream in self.getStreams():
      stream.delete(delChildren=TRUE)

  def getStreams(self):
    self.streams=self.getChildren("lng_stream")
    return self.streams

  def textHTML(self, out):
      out(u"<h1>%s</h1><br><br>" % (self.title,)
         )

      if self.scannr  <> 0 and self.scannr <> None  and self.scannr <> "None" and self.scannr <> "0":
        out(u"""<p><a href="KURA?command=list?table=lng_scan?scannr=%s">
  <img src="graphics/image.png" border=0 width=32 height=32 alt="scan">
  %s</a></p>""" % (self.scannr, self.scan))

      if self.recordingnr  <> 0 and self.recordingnr <> None and self.recordingnr <> "None" and self.recordingnr <> "0":
        rec=self.app.getObject('lng_recording', recordingnr=self.recordingnr)
        
        out(u"""<p><a href="%s">
  <img src="graphics/sound.png" border=0 width=32 height=32 alt="recording"></a></p>""" % (rec.url,))
      
      out(u"<p>%s</p>" % self.description)
      out("<h2>Interlinear</h2>")
      
      for stream in self.getStreams():
        stream.strmHTML(out, intext=TRUE)
        out("\n")
       
      out(u"<h2>Translation</h2>")
      out(self.translation())
      
      out(u"<p><small>Transcribed at %s by %s.</small></p>" % (self.transcription_date, self.user))

class lng_texts(dbTable):
  """
    Collection class for all text data.
  """
  def __init__(self, app):
  
    dbTable.__init__( self
                    , app
                    , table="lng_text"
                    , recObj=lng_text
                    )

  def recordHTML(self, out, keys={}):
    queryRec=self.recObj(self.app, fields=keys)
    self.select(queryRec)
    for row in self.rows:
      row.textHTML(out)

__copyright__="""
/***************************************************************************
    copyright            : (C) 2000 by Boudewijn Rempt 
                           see copyright notice for license
    email                : boud@rempt.xs4all.nl
    Revision             : $Revision: 1.9 $
    Last edited          : $Date: 2001/01/24 19:19:08 $
    
    CVS Log:         
    $Log: lng_text.py,v $
    Revision 1.9  2001/01/24 19:19:08  boud
    getStreams now returns [] not None when there are no streams.

    Revision 1.8  2001/01/15 20:21:15  boud
    Added import/export filters, bugfixes.

    Revision 1.7  2001/01/08 20:55:07  boud
    Cleanup for version 1.0

 ***************************************************************************/
"""
